let
  pkgs = import <nixpkgs> {};
in
  pkgs.mkShell {
    buildInputs = with pkgs; [
        cmake
        gdb
        SDL2
        SDL2.dev
        SDL2_image
        SDL2_gfx
        sqlite
        sqlite.dev
        libconfig
        libinput
        clang-tools_15
        valgrind
        xorg.xcbutil
        xorg.xcbutilkeysyms
        criterion
        clang-tools_16
        python311Packages.pip
        dash
    ];
    nativeBuildInputs = with pkgs; [
        pkg-config
    ];
    SDL2 = pkgs.SDL2;
    SDL2_image = pkgs.SDL2_image;
  }
