return require('packer').startup(function()
    use 'wbthomason/packer.nvim'
    use 'sonph/onehalf'
    use 'navarasu/onedark.nvim'
    use {
        'nvim-telescope/telescope.nvim', tag = '0.1.4',
        -- or                            , branch = '0.1.x',
        requires = { {'nvim-lua/plenary.nvim'} }
    }

    require('onedark').setup {
        style = 'darker'
    }
    require('onedark').load()
    -- use({
    --     'rose-pine/neovim',
    --     as = 'rose-pine',
    --     config = function()
    --         vim.cmd('colorscheme rose-pine')
    --     end
    -- }) 
    
    use {
        "williamboman/mason.nvim",
        "williamboman/mason-lspconfig.nvim",
        'neovim/nvim-lspconfig'
    }
    use 'hrsh7th/nvim-cmp' -- Autocompletion plugin
    use 'hrsh7th/cmp-nvim-lsp' -- Autocompletion with LSPs
    use 'hrsh7th/cmp-buffer'
    use 'hrsh7th/cmp-path'

    use {'neoclide/coc.nvim', branch = 'release'}

    use('nvim-treesitter/nvim-treesitter', {run = ':TSUpdate'})

    --use {
    --    'VonHeikemen/lsp-zero.nvim',
    --    branch = 'v2.x',
    --    requires = {
    --        -- LSP Support
    --        {'neovim/nvim-lspconfig'},
    --        {'williamboman/mason.nvim',  run = function()
    --            pcall(vim.cmd, 'MasonUpdate')
    --        end,},
    --        {'williamboman/mason-lspconfig.nvim'}, -- Optional

    --        -- Autocompletion
    --        {'hrsh7th/nvim-cmp'},     -- Required
    --        {'hrsh7th/cmp-nvim-lsp'}, -- Required
    --        {'L3MON4D3/LuaSnip'},     -- Required
    --    }
    --}

    -- Auto pairs
    use {
        "windwp/nvim-autopairs",
        config = function() require("nvim-autopairs").setup {} end
    }
    
    --harpoon
    use("theprimeagen/harpoon")

    ---- neogen
    --local i = require("neogen.types.template").item
    --local annotation = {
    --    { nil, "/**", { no_results = true, type = { "func", "file", "class" } } },
    --    { nil, "** \\file", { no_results = true, type = { "file" } } },
    --    { nil, "** \\brief $1", { no_results = true, type = { "func", "file", "class" } } },
    --    { nil, "*/", { no_results = true, type = { "func", "file", "class" } } },
    --    { nil, "", { no_results = true, type = { "file" } } },

    --    { nil, "/**", { type = { "func", "class", "type" } } },
    --    { i.ClassName, "** @class %s", { type = { "class" } } },
    --    { i.Type, "** @typedef %s", { type = { "type" } } },
    --    { nil, "** \\brief $1", { type = { "func", "class", "type" } } },
    --    { nil, "**", { type = { "func", "class", "type" } } },
    --    { i.Tparam, "** \\tparam %s $1" },
    --    { i.Parameter, "** \\param %s $1" },
    --    { i.Return, "** \\return $1" },
    --    { nil, "*/", { type = { "func", "class", "type" } } },
    --}
    --require("neogen").setup({
    --    languages = {
    --        c = {
    --            template = {
    --                annotation_convention = "my_annotation",
    --                my_annotation = annotation
    --            }
    --        }
    --    }
    --})
end)
